select
  extract(YEAR from ia.data) as "ANO"
  , mun.uf as "ESTADO"
  , mun.municipio as "MUNICIPIO"
  , ' ' as "RESPONSAVEL"
  , ' ' as "REGIONAL"
  , faz.nome as "PROPRIEDADE"
  , ' ' as "LOTE IATF"
  , an.numero as "N DA MATRIZ (INDIVIDUAL)"
  , (select GRAUSANGUE from sp_calculagrausangue(an.cdanimal)) as "RAA"
  , (case cat.cdcategoria
    when 6 then 'NOVILHA'
    when 7 then 'VACA'
    else null end) as "CATEGORIA"
  , ((select count(*)
    from reproducao
    where cdtiporeproducao = 1
      and cdanimal = an.cdanimal
      and data between coalesce(parant.data, '1900-01-01') and (ia.data+1))) as "1, 2 OU 3 IATF"
  , (select first 1 m.valor from medida m where m.cdanimal = ia.cdanimal and m.cdtipomedida = 2 and m.dtmedida >= (ia.data - 15)
        and m.dtmedida <= (ia.data + 15) order by m.dtmedida desc) as "ECC"
  , p.descricao
  , '' as "NMERO USO DISPOSITIVO"
  , ia.data as "DATA IA"
  , tou.numero as "NUMERO TOURO"
  , tou.nome as "NOME TOURO"
  , tou.idsemen as "COD TOURO" 
  , tou.regnumsemen as "REG TOURO" 
  , (select GRAUSANGUE from sp_calculagrausangue(tou.cdanimal)) as "RAA TOURO"
  , '' as "CENTRAL TOURO"
  , lp.numero as "PARTIDA"
  , ins.nome as "INSEMINADOR"
  , (case
    when dig.diagnostico = 'P' then 'POSITIVO'
    else 'NEGATIVO' end) as "RESULTADO DO DG"
  , ia.CONDICAOIA as "TIPO IA"
from
  fazenda faz
  join animal an on 1 = 1
  join reproducao ia on ia.cdanimal = an.cdanimal
    and ia.cdtiporeproducao = 1
  left join categoria cat on cat.cdcategoria =
    (select sp.cbasica from sp_categoriaanimal(ia.data, 'cdanimal = ' || an.cdanimal) sp)
  left join reproducao parant on parant.cdreproducao =
    (select first 1 re.cdreproducao
    from reproducao re
    where re.cdtiporeproducao = 7
      and re.data < ia.data
    order by re.data desc)
  left join medida m on m.cdanimal = an.cdanimal
    and m.cdtipomedida = 2
    and m.dtmedida = ia.data
  left join protocoloiatf p on p.cdprotocoloiatf = ia.cdprotocoloiatf
  left join animal tou on tou.cdanimal = ia.cdreprodutor
  left join loteproduto lp on ia.cdloteproduto = lp.cdloteproduto
  left join pessoa ins on ins.cdpessoa = ia.cdpessoa
  left join reproducao dig on dig.cdreproducao =
    (select first 1 re.cdreproducao from reproducao re where re.cdanimal = an.cdanimal
      and ((re.diagnostico is not null and re.cdtiporeproducao = 4) or (re.cdtiporeproducao in (1,2,3)))
      and re.data > ia.data
    order by re.data asc)
 left join municipio mun on faz.cdmunicipio = mun.cdmunicipio
WHERE IA.CONDICAOIA='I'
